#ifndef _H_KAVL2_DEFS
#define _H_KAVL2_DEFS

#include <kavl.h>

#define pmsk    0x7
#define rlnk    lun.rlnk
#define elnk    lun.elnk

enum kavl_branch_t
{
	LFT,
	RHT,
	PAR
};

enum kavl_balance_t
{
	LCR,
	LHE,
	BAL,
	RHE,
	RCR
};

enum kavl_mode_t
{
	INS,
	REM
};


enum kavl_class_t
{
	LEAF,
	BNCH,
	SUBT
};

typedef enum	kavl_branch_t	kavl_branch_t;
typedef enum	kavl_balance_t	kavl_balance_t;
typedef enum	kavl_mode_t	kavl_mode_t;
typedef enum	kavl_class_t	kavl_class_t;

#endif /* _H_KAVL2_DEFS */

