#ifndef _H_INJECT_
#define _H_INJECT_

#include <stdint.h>

typedef
struct DirEntry
{
    char     Name[11];
    uint8_t  Attribute;
    uint8_t  NTReserved;
    uint8_t  CreationTimeFine;
    uint16_t CreationTimeCoarse;
    uint16_t CreationDate;
    uint16_t LastAccessDate;
    uint16_t ClusterHigh;
    uint16_t LastWriteTime;
    uint16_t LastWriteDate;
    uint16_t ClusterLow;
    uint32_t Size;
}
__attribute__((packed))
DirEntry;

extern uint8_t *Clusters[];
extern uint8_t *FAT;
extern DirEntry *RootDir;

extern void SetCluster(uint16_t, uint16_t);
extern uint8_t InjectFile(const char *);
extern uint8_t DumpImage(const char *, const char *);

#endif /* _H_INJECT_ */
