#include <inj.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

uint8_t
DumpImage(const char *Out, const char *Boot)
{
    FILE *Generic;
    if (!(Generic = fopen(Boot, "rb")))
        return 0;

    uint8_t *Buffer;
    if (!(Buffer = malloc(0x200)))
        goto Error;
    if (!fread(Buffer, 0x200, 1, Generic))
        goto Error;

    fclose(Generic);
    if (!(Generic = fopen(Out, "wb")))
        goto Error;
    if (!fwrite(Buffer, 0x200, 1, Generic))
        goto Error;

    memset(Buffer, 0, 0x200);
    if (!fwrite(FAT, 4608, 2, Generic))
        goto Error;
    if (!fwrite(RootDir, 7168, 1, Generic))
        goto Error;

    uint8_t *WriteOut;
    for (uint16_t i = 0; i < 2847; i++)
    {
        WriteOut = (Clusters[i] ? Clusters[i] : Buffer);

        if (!fwrite(WriteOut, 512, 1, Generic))
            goto Error;
    }

    /* Success: */
        free(Buffer);
        fclose(Generic);
        return 1;

    Error:
        free(Buffer);
        fclose(Generic);
        return 0;
}
