#ifndef _H_KAVL2
#define _H_KAVL2

#include <stdint.h> /* for intN_t, uintN_t, uintptr_t */

typedef
struct kavl_node_t
{
	union
	{
		struct kavl_node_t *rlnk[3];
		uintptr_t elnk[3];
	}
	lun;

	uintptr_t k;
}
kavl_node_t;

extern kavl_node_t  *kavl_insert(kavl_node_t **, kavl_node_t *);
extern kavl_node_t **kavl_locate(kavl_node_t **, uintptr_t);
extern kavl_node_t  *kavl_remove(kavl_node_t **, kavl_node_t *);

#endif /* _H_KAVL2_ */

