#include <kavl_defs.h>

extern void kavl_maintain(kavl_node_t **, kavl_node_t *, kavl_mode_t);

kavl_node_t *
kavl_insert(kavl_node_t **r, kavl_node_t *n)
{
	kavl_node_t **ip = kavl_locate(r, n->k);
	if (!*ip)
	{
		*ip = n;
		n->elnk[PAR] = BAL;
		n->elnk[LFT] = n->elnk[RHT] = 0;

		if (ip != r)
		{
			ip = (kavl_node_t **)((uintptr_t)ip & ~pmsk);
			n->elnk[PAR] |= (uintptr_t)ip;

			((kavl_node_t *)ip)->elnk[PAR] +=
					((((kavl_node_t *)ip)->rlnk[RHT] == n) ? +1 : -1);

			kavl_maintain(r, (kavl_node_t *)ip, INS);
			return n;
		}
	}
	return *ip;
}

