#include <krdx.h>

krdx_node_t **
krdx_traverse(krdx_node_t **r, void *k, uintptr_t kl)
{
	if (*r)
	{
		uint8_t dir;
		uint8_t *bk = (uint8_t *)k;
		uintptr_t ntyp = (*r)->flg & 7; 

		while (ntyp != EXTERN)
		{
			if (ntyp == MARKED)
			{
				dir = (kl <= (*r)->inn.dpos);
			}
			else
			if (ntyp == INTERN)
			{
				dir = (bk[(*r)->inn.dpos >> 3] &
					(1 << ((*r)->inn.dpos & 7))) > 0;
			}
	
			r = &(*r)->inn.lnk[dir];
			ntyp = (*r)->flg & 7;
		}
	}
	return r;
}
